#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <time.h>
#include "kgb.h"
#include "util.h"
#include "modify.h"

void modify(KDB *kdb)
{
	Developer_Message();

	PrintHeadHtml(kdb->kdb);

	printf("<center>\n");
	printf("<table border='0'>\n");
	printf("<form METHOD='POST' action='%s'>\n", Program_Name);
	printf("    <tr>\n");
	printf("        <td><input type='hidden' name='kdb' value='%s'></td><td><input type='hidden' name='mode' value='modifyform'></td>\n", kdb->kdb);
	printf("    </tr>\n");
	printf("    <tr>\n");
	printf("        <td align='center' bgcolor='#fff0f0' colspan='2'><font face='Comic Sans MS' size='3'>Modify mode</font></td>\n");
	printf("    </tr>\n");
	printf("    <tr>\n");
	printf("        <td align='center' bgcolor='#f0f0f0'><font face='Arial' size='2'>Enter number</td><td><input type='text' name='number' size='5' maxlength='5'></td>\n");
	printf("    </tr>\n");
	printf("    <tr>\n");
	printf("        <td align='center' bgcolor='#f0f0f0'><font face='Arial' size='2'>Enter Password</td><td><input type='password' name='passwd' size='10' maxlength='8'></td>\n");
	printf("    </tr>\n");
	printf("    <tr>\n");
	printf("        <td colspan='2' align='center'><input type='submit' value='     Enter     '>\n");
	printf("    </tr>\n");
	printf("    <tr>\n");
	printf("        <td colspan='2' align='center'><a href='javascript:history.go(-1)' onMouseOver=\"window.status=('Go back'); return true;\"><img src='%sback.gif' border='0'></a></td>\n", Icon_Dir);
	printf("    </tr>\n");
	printf("</form>\n");
	printf("</table>\n");
	printf("</center>\n");

	PrintTailHtml(kdb->kdb);
}


void modifyform(KDB *kdb, CONFIG *config)
{
	Entry *Emodify;
	char file1[0xff], file2[0xff];
	char *temp;
	int i, num;

	if(kdb->number < 1 || kdb->number > config->lastnum)
		msg_error("Error!! Please, check data number");

	num = 0;
	for(i = 1; i < config->lastnum + 1; i++) {
		sprintf(file1, "%s%s/%d.bone", Save_Dir, kdb->kdb, i);
		sprintf(file2, "%s%s/%d.body", Save_Dir, kdb->kdb, i);

		if(FileCheck(file1) == 1 || FileCheck(file2) == 1)
			num++;

		if(num == kdb->number) {
			num = i;
			break;
		}
	}

	sprintf(file1, "%s%s/%d.bone", Save_Dir, kdb->kdb, num);
	Emodify = fileDecoder(file1);

	if(getFileValue(Emodify, "passwd") == NULL)
		temp = config->passwd;
	else
		temp = getFileValue(Emodify, "passwd");

	if(!strcmp(temp, uReturnPasswd(getValue("passwd"))) || !strcmp(config->passwd, uReturnPasswd(getValue("passwd")))) {

		Developer_Message();

		PrintHeadHtml(kdb->kdb);

		printf("<center>\n");
		printf("<table border='0' width='600'>\n");
		printf("<form method='post' action='%s'>\n", Program_Name);
		printf("    <tr><td colspan='2'><input type='hidden' name='kdb' value='%s'></td></tr>\n", kdb->kdb);
		printf("    <tr><td colspan='2'><input type='hidden' name='mode' value='modifysave'></td></tr>\n");
		printf("    <tr><td colspan='2'><input type='hidden' name='oldpass' value='%s'></td></tr>\n", getFileValue(Emodify, "passwd"));
		printf("    <tr><td colspan='2'><input type='hidden' name='number' value='%d'></td></tr>\n", num);
		printf("    <tr>\n");
		printf("        <td colspan='2'><hr size='0' noshade></td>\n");
		printf("    </tr>\n");
		if(strcmp(config->name, "NO")) {
			if(getFileValue(Emodify, "name") == NULL)
				temp = "";
			else
				temp = getFileValue(Emodify, "name");
			printf("    <tr>\n");
			if(!strcmp(config->language, "OK"))
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>Your Name</font></th><td><input type='text' name='name' size='30' maxlength='30' value='%s'></td>\n", temp);
			else
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='' size='2'>&nbsp;&nbsp;&nbsp;&nbsp;</font></th><td><input type='text' name='name' size='30' maxlength='30' value='%s'></td>\n", temp);
			printf("    </tr>\n");
		}
		if(strcmp(config->age, "NO")) {
			if(getFileValue(Emodify, "age") == NULL)
				temp = "";
			else
				temp = getFileValue(Emodify, "age");
			printf("    <tr>\n");
			if(!strcmp(config->language, "OK"))
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>Age</font></th><td><input type='text' name='age' size='30' maxlength='30' value='%s'></td>\n", temp);
			else
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='' size='2'>&nbsp;&nbsp;&nbsp;&nbsp;</font></th><td><input type='text' name='age' size='30' maxlength='30' value='%s'></td>\n", temp);
			printf("    </tr>\n");
		}
		if(strcmp(config->sex, "NO")) {
			printf("    <tr>\n");
			if(!strcmp(config->language, "OK"))
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>SEX</font></th>\n");
			else
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='' size='2'>&nbsp;&nbsp;&nbsp;&nbsp;</font></th>\n");
			printf("        <td>\n");
			printf("            <select name='sex'>\n");
			if(getFileValue(Emodify, "sex") == NULL)
				temp = "";
			else
				temp = getFileValue(Emodify, "sex");
			if(!strcmp(config->language, "OK")) {
				if(!strcmp(temp, "Male") && !strcmp(temp, "")) {
					printf("                <option value='Male'>Male\n");
					printf("                <option value=''>\n");
					printf("                <option value='Female'>Female\n");
				}
				else if(!strcmp(temp, "Female") && !strcmp(temp, "")) {
					printf("                <option value='Female'>Female\n");
					printf("                <option value=''>\n");
					printf("                <option value='Male'>Male\n");
				}
				else {
					printf("                <option value=''>\n");
					printf("                <option value='Male'>Male\n");
					printf("                <option value='Female'>Female\n");
				}
			}
			else {
				if(!strcmp(temp, "Male") && !strcmp(temp, "")) {
					printf("                <option value=''>\n");
					printf("                <option value=''>\n");
					printf("                <option value=''>\n");
				}
				else if(!strcmp(temp, "Female") && !strcmp(temp, "")) {
					printf("                <option value=''>\n");
					printf("                <option value=''>\n");
					printf("                <option value=''>\n");
				}
				else {
					printf("                <option value=''>\n");
					printf("                <option value=''>\n");
					printf("                <option value=''>\n");
				}
			}
			printf("            </select>\n");
			printf("        </td>\n");
			printf("    </tr>\n");
		}
		if(strcmp(config->address, "NO")) {
			if(getFileValue(Emodify, "address") == NULL)
				temp = "";
			else
				temp = getFileValue(Emodify, "address");
			printf("    <tr>\n");
			if(!strcmp(config->language, "OK"))
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>Address</font></th><td><input type='text' name='address' size='30' maxlength='100' value='%s'></td>\n", temp);
			else
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='' size='2'>&nbsp;&nbsp;</font></th><td><input type='text' name='address' size='30' maxlength='100' value='%s'></td>\n", temp);
			printf("    </tr>\n");
		}
		if(strcmp(config->telephone, "NO")) {
			if(getFileValue(Emodify, "telephone") == NULL)
				temp = "";
			else
				temp = getFileValue(Emodify, "telephone");
			printf("    <tr>\n");
			if(!strcmp(config->language, "OK"))
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>Telephone</font></th><td><input type='text' name='telephone' size='30' maxlength='30' value='%s'></td>\n", temp);
			else
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='' size='2'>ȭȣ</font></th><td><input type='text' name='telephone' size='30' maxlength='30' value='%s'></td>\n", temp);
			printf("    </tr>\n");
		}
		if(strcmp(config->email, "NO")) {
			if(getFileValue(Emodify, "email") == NULL)
				temp = "";
			else
				temp = getFileValue(Emodify, "email");
			printf("    <tr>\n");
			printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>E-mail</font></th><td><input type='text' name='email' size='30' maxlength='30' value='%s'></td>\n", temp);
			printf("    </tr>\n");
		}
		if(strcmp(config->homeurl, "NO")) {
			if(getFileValue(Emodify, "homeurl") == NULL)
				temp = "";
			else
				temp = getFileValue(Emodify, "homeurl");
			printf("    <tr>\n");
			if(!strcmp(config->language, "OK"))
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>Homepage URL</font></th><td><font face='Arial' size='2'>http://</font><input type='text' name='homeurl' size='50' maxlength='50' value='%s'></td>\n", temp);
			else
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='' size='2'>Ȩ ּ</font></th><td><font face='Arial' size='2'>http://</font><input type='text' name='homeurl' size='50' maxlength='50' value='%s'></td>\n", temp);
			printf("    </tr>\n");
		}
		if(strcmp(config->hometitle, "NO")) {
			if(getFileValue(Emodify, "hometitle") == NULL)
				temp = "";
			else
				temp = getFileValue(Emodify, "hometitle");
			printf("    <tr>\n");
			if(!strcmp(config->language, "OK"))
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>Homepage title</font></th><td><input type='text' name='hometitle' size='60' maxlength='100' value='%s'></td>\n", temp);
			else
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='' size='2'>Ȩ </font></th><td><input type='text' name='hometitle' size='60' maxlength='100' value='%s'></td>\n", temp);
			printf("    </tr>\n");
		}
		sprintf(file2, "%s%s/%d.body", Save_Dir, kdb->kdb, num);
		if(strcmp(config->body, "NO")) {
			printf("    <tr>\n");
			if(!strcmp(config->language, "OK"))
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>Contents</font></th><td><textarea name='body' cols='60' rows='10' wrap='physical'>");
			else
				printf("        <th bgcolor='#f0f0f0' width='150'><font face='' size='2'>&nbsp;&nbsp;&nbsp;&nbsp;</font></th><td><textarea name='body' cols='60' rows='10' wrap='physical'>");
			
			print_html_code(file2);printf("</textarea></td>\n");
			printf("    </tr>\n");
		}
		printf("    <tr>\n");
		printf("        <td colspan='2'><hr size='0' noshade></td>\n");
		printf("    </tr>\n");
		printf("    <tr>\n");
		printf("        <th bgcolor='#f0f0f0' width='150'><font face='Arial' size='2'>New Password</font></th><td><input type='password' name='passwd' size='10' maxlength='8'></td>\n");
		printf("    </tr>\n");
		printf("    <tr>\n");
		printf("        <td colspan='2'><hr size='0' noshade></td>\n");
		printf("    </tr>\n");
		printf("</table>\n");
		printf("<table border='0' width='600'>\n");
		printf("    <tr>\n");
		printf("        <td align='left' width='150'><input type='reset' value='  Reset  '></td><td align='center'><input type='submit' value='          Save          '></td><td align='right' width='150'>");
		if(strcmp(config->helpurl, "")) {
			if(strcmp(config->htarget, ""))
				sprintf(file1, " target='%s'", config->htarget);
			else
				strcpy(file1, "");
			printf("<a href='%s'%s onMouseOver=\"window.status=('Help'); return true;\"><img src='%shelp.gif' border=0 alt='help'></a>", config->helpurl, file1, Icon_Dir);
		}
		printf("<a href='%s?kdb=%s&mode=list' onMouseOver=\"window.status=('List'); return true;\"><img src='%slist.gif' border='0' alt='list'></a></td>\n", Program_Name, kdb->kdb, Icon_Dir);
		printf("    </tr>\n");
		printf("</form>\n");
		printf("</table>\n");
		printf("</center>\n");

		PrintTailHtml(kdb->kdb);
	}
	else
		msg_error("Error!! Check Password");

	entryFileFree(Emodify);
}


void modifysave(KDB *kdb, CONFIG *config)
{
	FILE *fp, *mp;
	char buff[0xff];
	long timeptr;
	char ch;

	time(&timeptr);

	sprintf(buff, "%s%s/%d.bone", Save_Dir, kdb->kdb, kdb->number);
	if((fp = fopen(buff, "wt")) == NULL)
		msg_error("Error!! Please, You should better call the administror");

	if(!strcmp(getValue("passwd"), ""))
		fprintf(fp, "passwd=%s\n", getValue("oldpass"));
	else
		fprintf(fp, "passwd=%s\n", uReturnPasswd(getValue("passwd")));

	if(!strcmp(config->name, "OK")) {
		if(!strcmp(getValue("name"), ""))
			msg_error("Error!! Please, Write your name");
		else 
			fprintf(fp, "name=%s\n", getValue("name"));
	}
	else if(getValue("name") != NULL)
		if(strcmp(getValue("name"), ""))
			fprintf(fp, "name=%s\n", getValue("name"));

	if(!strcmp(config->age, "OK")) {
		if(!strcmp(getValue("age"), ""))
			msg_error("Error!! Please, Write your age");
		else 
			fprintf(fp, "age=%s\n", getValue("age"));
	}
	else if(getValue("age") != NULL)
		if(strcmp(getValue("age"), ""))
			fprintf(fp, "age=%s\n", getValue("age"));

	if(!strcmp(config->sex, "OK")) {
		if(!strcmp(getValue("sex"), ""))
			msg_error("Error!! Please, Write your sex");
		else 
			fprintf(fp, "sex=%s\n", getValue("sex"));
	}
	else if(getValue("sex") != NULL)
		if(strcmp(getValue("sex"), ""))
			fprintf(fp, "sex=%s\n", getValue("sex"));

	if(!strcmp(config->address, "OK")) {
		if(!strcmp(getValue("address"), ""))
			msg_error("Error!! Please, Write your address");
		else 
			fprintf(fp, "address=%s\n", getValue("address"));
	}
	else if(getValue("address") != NULL)
		if(strcmp(getValue("address"), ""))
			fprintf(fp, "address=%s\n", getValue("address"));

	if(!strcmp(config->telephone, "OK")) {
		if(!strcmp(getValue("telephone"), ""))
			msg_error("Error!! Please, Write your telephone");
		else
			fprintf(fp, "telephone=%s\n", getValue("telephone"));
	}
	else if(getValue("telephone") != NULL)
		if(strcmp(getValue("telephone"), ""))
			fprintf(fp, "telephone=%s\n", getValue("telephone"));

	if(!strcmp(config->email, "OK")) {
		if(!strcmp(getValue("email"), ""))
			msg_error("Error!! Please, Write your E-mail");
		else
			fprintf(fp, "email=%s\n", getValue("email"));
	}
	else if(getValue("email") != NULL)
		if(strcmp(getValue("email"), ""))
			fprintf(fp, "email=%s\n", getValue("email"));

	if(!strcmp(config->homeurl, "OK")) {
		if(!strcmp(getValue("homeurl"), ""))
			msg_error("Error!! Please, Write your Homepage URL");
		else 
			fprintf(fp, "homeurl=%s\n", getValue("homeurl"));
	}
	else if(getValue("homeurl") != NULL)
		if(strcmp(getValue("homeurl"), ""))
			fprintf(fp, "homeurl=%s\n", getValue("homeurl"));

	if(!strcmp(config->hometitle, "OK")) {
		if(!strcmp(getValue("hometitle"), ""))
			msg_error("Error!! Please, Write your Homepage Title");
		else 
			fprintf(fp, "hometitle=%s\n", getValue("hometitle"));
	}
	else if(getValue("hometitle") != NULL)
		if(strcmp(getValue("hometitle"), ""))
			fprintf(fp, "hometitle=%s\n", getValue("hometitle"));

	fprintf(fp, "remoteaddr=%s\n", getenv("REMOTE_ADDR"));
	fprintf(fp, "localtime=%s\n", ctime(&timeptr));

	fclose(fp);

	sprintf(buff, "%s%s/%d.body", Save_Dir, kdb->kdb, kdb->number);
	if(!strcmp(config->body, "OK")) {
		if(!strcmp(getValue("body"), ""))
			msg_error("Error!! Please, Write Body text ");
		else
			uWriteFile(buff, getValue("body"));
	}
	else if(getValue("body") != NULL)
		if(strcmp(getValue("body"), ""))
			uWriteFile(buff, getValue("body"));

	/* send mail */
	if(!strcmp(config->adsendmail, "OK")) {
		sprintf(buff, "%s/sendmail %s", Mail_Dir, Mail_Opt);

		if((fp = popen(buff, "wt")) == NULL)
			msg_error("Error!! Please, check sendmail directory");

		fprintf(fp, "From: KissCGIGuestbook-Mailer <%s>\n", config->adminmail);
		fprintf(fp, "Reply-To: KissCGIGuestbook-Mailer <%s>\n", config->adminmail);
		fprintf(fp, "X-Mailer: %s %s\n", Title_Name, Program_Version);
		fprintf(fp, "To: %s\n", config->adminmail);
		fprintf(fp, "Subject: Kiss CGI Guestbook Modify Message\n");

		fprintf(fp, "\n");
		fprintf(fp, "   [ Modify Message ]\n");
		fprintf(fp, "\n");
		fprintf(fp, "Data Number    : %d\n", kdb->number);
		fprintf(fp, "Time/Date      : %s\n", ctime(&timeptr));
		fprintf(fp, "\n");

		if(getValue("name")      != NULL && strcmp(getValue("name"), ""))
			fprintf(fp, "Name           : %s\n", getValue("name"));
		if(getValue("age")       != NULL && strcmp(getValue("age"), ""))
			fprintf(fp, "Age            : %s\n", getValue("age"));
		if(getValue("sex")       != NULL && strcmp(getValue("sex"), ""))
			fprintf(fp, "Sex            : %s\n", getValue("sex"));
		if(getValue("address")   != NULL && strcmp(getValue("address"), ""))
			fprintf(fp, "Address        : %s\n", getValue("address"));
		if(getValue("telephone") != NULL && strcmp(getValue("telephone"), ""))
			fprintf(fp, "Telephone      : %s\n", getValue("telephone"));
		if(getValue("email")     != NULL && strcmp(getValue("email"), ""))
			fprintf(fp, "E-Mail         : %s\n", getValue("email"));
		if(getValue("homeurl")   != NULL && strcmp(getValue("homeurl"), ""))
			fprintf(fp, "Home Page      : http://%s\n", getValue("homeurl"));
		if(getValue("hometitle") != NULL && strcmp(getValue("hometitle"), ""))
			fprintf(fp, "Homepage Title : %s\n", getValue("hometitle"));
		fprintf(fp, "\n");

		sprintf(buff, "%s%s/%d.body", Save_Dir, kdb->kdb, kdb->number);
		if((mp = fopen(buff, "rt")) != NULL) {
			fprintf(fp, "Contents       :\n");
			fprintf(fp, "\n");
			while((ch = fgetc(mp)) != EOF)
				fprintf(fp, "%c", ch);
			fclose(mp);
		}
		pclose(fp);
	}
}
