#include <stdio.h>
#include <stdlib.h>
#include "kdbm.h"

void createDB(void);
void deleteDB(void);
void file_error(void);
void prg_info(void);
void dev_msg(void);

int main(void)
{
	int select;

	prg_info();

	printf("\n     One's choice number\n");
	printf("      1. Create database\n");
	printf("      2. Delete database\n");
	printf("      0. Exit\n\n");

	while(1) {
		printf("Choice => ");
		scanf("%d", &select);

		if(select == 1) {
			createDB();
			break;
		}
		if(select == 2) {
			deleteDB();
			break;
		}
		if(select == 0)
			break;
	}

	dev_msg();
	return 0;
}


void createDB(void)
{
	FILE *fp;
	char buffer[0xff];
	char kdbname[0xff];

	printf("\nEnter Database name => ");
	scanf("%s", kdbname);

	sprintf(buffer, "mkdir %s%s", Save_Dir, kdbname);
	system(buffer);

	sprintf(buffer, "%s%s/%s", Save_Dir, kdbname, kdbname);

	if((fp = fopen(buffer, "wt")) == NULL)
		file_error();
	fprintf(fp, "%s", config_default);
	fclose(fp);

	printf("\nSucess creat database !!\n");
	printf("Usage => http://[your host]/[this directory]/%s?kdb=%s\n\n", Program_Name, kdbname);
}


void deleteDB(void)
{
	FILE *fp;
	char buffer[0xff];
	char kdbname[0xff];

	printf("\nEnter delete Database name => ");
	scanf("%s", kdbname);

	sprintf(buffer, "%s%s/%s", Save_Dir, kdbname, kdbname);
	if((fp = fopen(buffer, "rt")) == NULL) {
		printf("Can not find database...\n");
		return;
	}
	fclose(fp);

	sprintf(buffer, "rm -rf %s%s", Save_Dir, kdbname);
	system(buffer);

	sprintf(buffer, "rm -f %s%s.kdbm", Save_Dir, kdbname);
	system(buffer);

	printf("\nDeleted database..\n\n");
}

void file_error(void)
{
	printf("Error!!\n");
	printf("check 'file' or 'permission' (save directory)\n\n");
	dev_msg();
	exit(1);
}

void prg_info(void)
{
	printf("------------------------------------------\n");
	printf("-   Kiss CGI Guestbook Database Maker    -\n");
	printf("------------------------------------------\n");
}

void dev_msg(void)
{
	printf("------------------------------------------\n");
	printf("-   Developed by 'Hoon-joo, Kang'        -\n");
	printf("-   E-mail   : aeokiss@shinbiro.com      -\n");
	printf("-   Homepage : http://aeokiss.town.cc    -\n");
	printf("-   Thank you.                           -\n");
	printf("------------------------------------------\n");
}
