#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "kgb.h"
#include "util.h"
#include "list.h"

void _colorDisplay_Font(char *color);
void _colorDisplay_Back(char *color);

void list(KDB *kdb, CONFIG *config)
{
	Entry *Econfig;

	char buff1[0xff], buff2[0xff], *temp;
	int firstnum, pagenum, visualnum, pagetemp, up, down, tmp1, tmp2;
	
	sprintf(buff1, "%s%s/count.dat", Save_Dir, kdb->kdb);
	if((config->count = uReadNum(buff1)) < 0)
		config->count = 0;

	config->count++;

	if(config->volume > 10)
		pagenum = ((config->volume - 1) / 10) + 1;
	else
		pagenum = 1;

	if(kdb->page == 1)
		visualnum = config->volume;
	else
		visualnum = config->volume - ((kdb->page - 1) * 10);

	/* ش  ù°  ȣ */
	firstnum = kdb->pageact[kdb->page];

	Developer_Message();

	PrintHeadHtml(kdb->kdb);

	if(!strcmp(config->underline, "NO"))
		Disable_Underlined();

	printf("\n");
	printf("<center>\n");

	/* ܸ޴ */
	if(!strcmp(config->menuup, "OK")) {
		printf("\n");
		printf("<!-- Menu (top) -->\n");
		printf("<table border='0' width='600'>\n");
		printf("    <tr>\n");
		printf("        <td align='left'>\n");
		printf("        <a href='%s?kdb=%s&mode=admin' onMouseOver=\"window.status=('Admin'); return true;\"><img src='%sadmin.gif' border=0 alt='admin'></a>\n", Program_Name, kdb->kdb, Icon_Dir);
		if(pagenum > kdb->page) {
			pagetemp = kdb->page + 1;
			printf("        <a href='%s?kdb=%s&mode=list&page=%d' onMouseOver=\"window.status=('Forward'); return true;\"><img src='%sforward.gif' border=0 alt='forward'></a>\n", Program_Name, kdb->kdb, pagetemp, Icon_Dir);
		}
		if(kdb->page > 1) {
			pagetemp = kdb->page - 1;
			printf("        <a href='%s?kdb=%s&mode=list&page=%d' onMouseOver=\"window.status=('Backward'); return true;\"><img src='%sbackward.gif' border=0 alt='backward'></a>\n", Program_Name, kdb->kdb, pagetemp, Icon_Dir);
		}
		printf("        </td>\n");
		printf("        <td align='right'>\n");
		printf("        <a href='%s?kdb=%s&mode=write' onMouseOver=\"window.status=('Write'); return true;\"><img src='%swrite.gif' border=0 alt='write'></a>\n", Program_Name, kdb->kdb, Icon_Dir);
		printf("        <a href='%s?kdb=%s&mode=del' onMouseOver=\"window.status=('Delete'); return true;\"><img src='%sdelete.gif' border=0 alt='delete'></a>\n", Program_Name, kdb->kdb, Icon_Dir);
		if(!strcmp(config->modifyarticle, "OK")) {
			printf("        <a href='%s?kdb=%s&mode=modify' onMouseOver=\"window.status=('Modify'); return true;\"><img src='%smodify.gif' border=0 alt='modify'></a>\n", Program_Name, kdb->kdb, Icon_Dir);
		}
		if(strcmp(config->helpurl, "")) {
			if(strcmp(config->htarget, ""))
				sprintf(buff1, " target='%s'", config->htarget);
			else
				strcpy(buff1, "");
			printf("        <a href='%s'%s onMouseOver=\"window.status=('Help'); return true;\"><img src='%shelp.gif' border=0 alt='help'></a>\n", config->helpurl, buff1, Icon_Dir);
		}

		printf("        <a href='%s?kdb=%s&mode=list&page=%d' onMouseOver=\"window.status=('Reload list'); return true;\"><img src='%sreload.gif' border=0 alt='reload'></a>\n", Program_Name, kdb->kdb, kdb->page, Icon_Dir);

		if(strcmp(config->ahomeurl, "")) {
			if(strcmp(config->atarget, ""))
				sprintf(buff1, " target='%s'", config->atarget);
			else
				strcpy(buff1, "");
			printf("        <a href='%s'%s onMouseOver=\"window.status=('Home'); return true;\"><img src='%shome.gif' border=0 alt='home'></a>\n", config->ahomeurl, buff1, Icon_Dir);
		}

		if(strcmp(config->backurl, "")) {
			if(strcmp(config->btarget, ""))
				sprintf(buff1, " target='%s'", config->btarget);
			else
				strcpy(buff1, "");
			printf("        <a href='%s'%s onMouseOver=\"window.status=('Back'); return true;\"><img src='%sback.gif' border=0 alt='back'></a>\n", config->backurl, buff1, Icon_Dir);
		}

		printf("        </td>\n");
		printf("    </tr>\n");
		printf("</table>\n");
	}

	printf("<table border='0' width='600' cellspacing='0'>\n");
	printf("    <tr bgcolor='#f0f0f0'>\n");
	printf("        <td align='left'><font face='Arial' color='black' size='2'><b>Total Access. %ld</b></font></td><td align='right'><font face='Arial' size='2'><b>Page. %d</b></font></td>\n", config->count, kdb->page);
	printf("    </tr>\n");
	printf("    <tr>\n");
	printf("        <td colspan='2' align='center'><font face='Arial' size='1'>");

	/*   ٷΰ */
	if(kdb->page > 10) {
		up = (((kdb->page - 1) / 10) * 10) - 9;
		down = up + 9;
		printf("&lt;<a href='%s?kdb=%s&mode=list&page=1'>first</a>&gt; ", Program_Name, kdb->kdb);
		printf("&lt;<a href='%s?kdb=%s&mode=list&page=%d'>%d - %d</a>&gt; ", Program_Name, kdb->kdb, up, up, down);
	}

	up = (((kdb->page - 1) / 10) * 10) + 1;
	down = up + 9;
	for(pagetemp = up; pagetemp <= down; pagetemp++) {
		if(pagetemp == kdb->page)
			printf("&lt;<b>%d</b>&gt;", pagetemp);
		else
			printf("&lt;<a href='%s?kdb=%s&mode=list&page=%d'>%d</a>&gt;", Program_Name, kdb->kdb, pagetemp, pagetemp);
		if(pagetemp == pagenum)
			break;
	}

	tmp1 = (pagenum - 1) / 10;
	tmp2 = (kdb->page - 1) / 10;
	if(tmp1 > tmp2) {
		up = (((kdb->page - 1) / 10) * 10) + 11;
		down = up + 9;
		printf(" &lt;<a href='%s?kdb=%s&mode=list&page=%d'>%d - %d</a>&gt;", Program_Name, kdb->kdb, up, up, down);
		printf(" &lt;<a href='%s?kdb=%s&mode=list&page=%d'>last</a>&gt;", Program_Name, kdb->kdb, pagenum);
	}

	printf("</font></td>\n");
	printf("    </tr>\n");
	printf("</table>\n");
	printf("<hr size='0' noshade width='600'>\n");
	printf("\n");
	printf("<!-- guestbook text -->\n");

	pagetemp = 1;
	while(1) {
		if(pagetemp > 10 || firstnum < 1)
			break;

		sprintf(buff1, "%s%s/%d.bone", Save_Dir, kdb->kdb, firstnum);
		sprintf(buff2, "%s%s/%d.body", Save_Dir, kdb->kdb, firstnum);

		if(FileCheck(buff1) == 1 || FileCheck(buff2) == 1) {
			Econfig = fileDecoder(buff1);

			printf("\n");
			printf("<!-- Data number : %d -->\n", firstnum);
			printf("<table border='0' width='594'>\n");
			printf("    <tr><td align='left'");_colorDisplay_Back(config->topbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->topfcolor);printf(" size='2'><b>No. %d</b></font></td><td align='right'", visualnum);_colorDisplay_Back(config->topbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->topfcolor);printf(" size='1'>[%s] , from : [%s]</font></td></tr>\n", getFileValue(Econfig, "localtime"), getFileValue(Econfig, "remoteaddr"));
			temp = getFileValue(Econfig, "name");
			if(temp != NULL && temp != "") {
				if(!strcmp(config->language, "OK")) {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Name</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
				else {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face=''");_colorDisplay_Font(config->themefcolor);printf(" size='2'>&nbsp;&nbsp;&nbsp;&nbsp;</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face=''");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
			}
			temp = getFileValue(Econfig, "age");
			if(temp != NULL && temp != "") {
				if(!strcmp(config->language, "OK")) {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Age</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
				else {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face=''");_colorDisplay_Font(config->themefcolor);printf(" size='2'>&nbsp;&nbsp;&nbsp;&nbsp;</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face=''");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
			}
			temp = getFileValue(Econfig, "sex");
			if(temp != NULL && temp != "") {
				if(!strcmp(config->language, "OK")) {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>SEX</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
				else {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face=''");_colorDisplay_Font(config->themefcolor);printf(" size='2'>&nbsp;&nbsp;&nbsp;&nbsp;</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face=''");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
			}
			temp = getFileValue(Econfig, "address");
			if(temp != NULL && temp != "") {
				if(!strcmp(config->language, "OK")) {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Address</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
				else {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face=''");_colorDisplay_Font(config->themefcolor);printf(" size='2'>&nbsp;&nbsp;</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face=''");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
			}
			temp = getFileValue(Econfig, "telephone");
			if(temp != NULL && temp != "") {
				if(!strcmp(config->language, "OK")) {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Telephone</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
				else {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face=''");_colorDisplay_Font(config->themefcolor);printf(" size='2'>ȭȣ</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face=''");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
			}
			temp = getFileValue(Econfig, "email");
			if(temp != NULL && temp != "") {
				printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>E-mail</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'><a href='mailto:%s'>%s</a></font></td></tr>\n", temp, temp);
			}
			temp = getFileValue(Econfig, "homeurl");
			if(temp != NULL && temp != "") {
				if(!strcmp(config->language, "OK")) {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Homepage URL</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'><a href='http://%s' target='_top'>http://%s</a></font></td></tr>\n", temp, temp);
				}
				else {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face=''");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Ȩ ּ</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face=''");_colorDisplay_Font(config->contentfcolor);printf(" size='2'><a href='http://%s' target='_top'>http://%s</a></font></td></tr>\n", temp, temp);
				}
			}
			temp = getFileValue(Econfig, "hometitle");
			if(temp != NULL && temp != "") {
				if(!strcmp(config->language, "OK")) {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Homepage Title</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
				else {
					printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face=''");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Ȩ </font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face=''");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>%s</font></td></tr>\n", temp);
				}
			}
			sprintf(buff2, "%s%s/%d.body", Save_Dir, kdb->kdb, firstnum);
			if(!strcmp(config->language, "OK")) {
				printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face='Arial'");_colorDisplay_Font(config->themefcolor);printf(" size='2'>Contents</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face='Arial'");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>");
			}
			else {
				printf("    <tr><td align='center'");_colorDisplay_Back(config->themebcolor);printf("><font face=''");_colorDisplay_Font(config->themefcolor);printf(" size='2'>&nbsp;&nbsp;&nbsp;&nbsp;</font></td><td");_colorDisplay_Back(config->contentbcolor);printf("><font face=''");_colorDisplay_Font(config->contentfcolor);printf(" size='2'>");
			}

			if(!strcmp(config->accepthtml, "NO"))
				uBodyReadFile(buff2, 1);
			else
				uBodyReadFile(buff2, 0);
			printf("</font></td></tr>\n");
			/* ׽  󿡼 ̺ ũⰡ   Ƿ  ̹ ؼ ̺ ũ⸦ ״ */
			printf("    <tr><td><img src='%sline.gif' height='1' width='148' border='0'></td><td><img src='%sline.gif' height='1' width='448' border='0'></td></tr>\n", Icon_Dir, Icon_Dir);
			printf("</table>\n");
			printf("<hr size='0' noshade width='600'>\n\n");
			pagetemp++;
			visualnum--;
			if(pagetemp == 11 || visualnum == 0)
				printf("<table border='0' width='594'><tr><td align='right'><font face='Arial' size='1' color='#747474'>%s %s</font></td></tr></table>\n", Title_Name, Program_Version);

			entryFileFree(Econfig);
		}
		firstnum--;
	}

	printf("\n");
	printf("<!-- Menu (lower) -->\n");
	printf("<table border='0' width='600'>\n");
	printf("    <tr>\n");
	printf("        <td align='left'>\n");
	printf("        <a href='%s?kdb=%s&mode=admin' onMouseOver=\"window.status=('Admin'); return true;\"><img src='%sadmin.gif' border=0 alt='admin'></a>\n", Program_Name, kdb->kdb, Icon_Dir);
	if(pagenum > kdb->page) {
		pagetemp = kdb->page + 1;
		printf("        <a href='%s?kdb=%s&mode=list&page=%d' onMouseOver=\"window.status=('Forward'); return true;\"><img src='%sforward.gif' border=0 alt='forward'></a>\n", Program_Name, kdb->kdb, pagetemp, Icon_Dir);
	}
	if(kdb->page > 1) {
		pagetemp = kdb->page - 1;
		printf("        <a href='%s?kdb=%s&mode=list&page=%d' onMouseOver=\"window.status=('Backward'); return true;\"><img src='%sbackward.gif' border=0 alt='backward'></a>\n", Program_Name, kdb->kdb, pagetemp, Icon_Dir);
	}
	printf("        </td>\n");
	printf("        <td align='right'>\n");
	printf("        <a href='%s?kdb=%s&mode=write' onMouseOver=\"window.status=('Write'); return true;\"><img src='%swrite.gif' border=0 alt='write'></a>\n", Program_Name, kdb->kdb, Icon_Dir);
	printf("        <a href='%s?kdb=%s&mode=del' onMouseOver=\"window.status=('Delete'); return true;\"><img src='%sdelete.gif' border=0 alt='delete'></a>\n", Program_Name, kdb->kdb, Icon_Dir);
	if(!strcmp(config->modifyarticle, "OK")) {
		printf("        <a href='%s?kdb=%s&mode=modify' onMouseOver=\"window.status=('Modify'); return true;\"><img src='%smodify.gif' border=0 alt='modify'></a>\n", Program_Name, kdb->kdb, Icon_Dir);
	}
	if(strcmp(config->helpurl, "")) {
		if(strcmp(config->htarget, ""))
			sprintf(buff1, " target='%s'", config->htarget);
		else
			strcpy(buff1, "");
		printf("        <a href='%s'%s onMouseOver=\"window.status=('Help'); return true;\"><img src='%shelp.gif' border=0 alt='help'></a>\n", config->helpurl, buff1, Icon_Dir);
	}

	printf("        <a href='%s?kdb=%s&mode=list&page=%d' onMouseOver=\"window.status=('Reload list'); return true;\"><img src='%sreload.gif' border=0 alt='reload'></a>\n", Program_Name, kdb->kdb, kdb->page, Icon_Dir);

	if(strcmp(config->ahomeurl, "")) {
		if(strcmp(config->atarget, ""))
			sprintf(buff1, " target='%s'", config->atarget);
		else
			strcpy(buff1, "");
		printf("        <a href='%s'%s onMouseOver=\"window.status=('Home'); return true;\"><img src='%shome.gif' border=0 alt='home'></a>\n", config->ahomeurl, buff1, Icon_Dir);
	}

	if(strcmp(config->backurl, "")) {
		if(strcmp(config->btarget, ""))
			sprintf(buff1, " target='%s'", config->btarget);
		else
			strcpy(buff1, "");
		printf("        <a href='%s'%s onMouseOver=\"window.status=('Back'); return true;\"><img src='%sback.gif' border=0 alt='back'></a>\n", config->backurl, buff1, Icon_Dir);
	}

	printf("        </td>\n");
	printf("    </tr>\n");
	printf("</table>\n");
	printf("</center>\n");

	PrintTailHtml(kdb->kdb);

	sprintf(buff1, "%s%s/count.dat", Save_Dir, kdb->kdb);
	uWriteNum(buff1, config->count);
}

void _colorDisplay_Font(char *color)
{
	if(color != NULL && strcmp(color, ""))
		printf(" color='%s'", color);
}

void _colorDisplay_Back(char *color)
{
	if(color != NULL && strcmp(color, ""))
		printf(" bgcolor='%s'", color);
}
