#ifndef UTIL_H
#define UTIL_H

typedef struct Entry {
	char *name;
	char *value;
	struct Entry *next;
} Entry;

/* decoder */
char *getValue(char *name);
int Decoder(void);
void entryFree(void);
Entry *fileDecoder(char *filename);
char *getFileValue(Entry *first, char *name);
void entryFileFree(Entry *first);

/* file access */
void uReadFile(char *filename);
void uBodyReadFile(char *filename, int flag);
void print_html_code(char *filename);
char *ucReadFile(char *filename);
void uWriteFile(char *filename, char *body);
char *uReturnPasswd(char *string);
char *crypt(const char *key, const char *salt);
int uReadNum(char *filename);
int uWriteNum(char *filename, unsigned long num);
int FileCheck(char *filename);

/* message */
void msg_error(char *eMsg);
void Content_Type(char *Type);
void Disable_Underlined(void);

#endif
